package com.example.web;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import com.example.model.BeerExpert;
import com.opensymphony.xwork2.ActionSupport;

public class BeerSelectAction extends ActionSupport implements
		ServletRequestAware // extends Action
{
	private static final long serialVersionUID = 8450666311336329411L;
	private HttpServletRequest request;
	private String color;
	private static final String VALID_COLORS = "amber,dark,light,brown";

	/**
	 * 
	 * @return the result of the method execution
	 */
	public String execute() {

		// Process the business logic
		// checks if the color is set and if it has valid value
		// if not reports an error
		if (color != null && VALID_COLORS.indexOf(color) == -1) {
			addActionError("error");
			return "error";
		} else {
			// for chosen color gets the advice from the <code>BeerExpert</code>
			BeerExpert be = new BeerExpert();
			List<String> result = be
					.getBrands((getColor() != null) ? getColor() : "light");

			// stores the result in the request-scope
			request.setAttribute("styles", result);
			// reports that action was executed successfully
			return "success";
		}
	}

	@Override
	public void setServletRequest(HttpServletRequest request) {
		this.request = request;

	}

	/**
	 * setter for the form parameter <code>color</code>
	 * 
	 * @param color
	 */
	public void setColor(String color) {
		this.color = color;
	}

	/**
	 * getter for the form parameter <code>color</code>
	 * 
	 * @return the color chosen in the form
	 */
	public String getColor() {
		return color;
	}

}
